#include "audio.h"
#include <stdlib.h>
#include <QProcess>
#include <QSound>
#include <QDebug>
#include <QFile>
#include <QDesktopServices>
#include <phonon/MediaObject>
#include <phonon/MediaSource>

Audio::Audio(QObject *parent) :
    QObject(parent)
{


}

void Audio::createWav(QString filename)
{
    reader = new Reader();
    connect(reader, SIGNAL(finished()), this, SLOT(threadFinished()));
    connect(reader,SIGNAL(destroyed()), this, SLOT(threadDeleted()));

    QString audio = filename;
    audio.chop(3);
    audio.append("wav");
    audioFile = new QFile(audio);

    reader->setFileName(filename);

    reader->start();
   /* if (!audioFile->open(QIODevice::ReadWrite))
        qDebug()<<"cannot write to file";
    else
    {
        QString program = "flite"; //espeak
        QStringList arguments;

        arguments << "-voice" << "kal16" << "-f" << filename << "-o" << audio; //arguments << "-f" << filename << "-s" << "110" << "-v " << "en/en-rp" << -w << audio;
        qDebug()<<arguments;
        QProcess *myProcess = new QProcess();

        file = audio;

        myProcess->start(program, arguments);
        myProcess->waitForFinished();



    }*/

}

void Audio::threadDeleted()
{
    this->wavCreated();
}

void Audio::threadFinished()
{
    qDebug()<<"done 2";
    music = Phonon::createPlayer(Phonon::MusicCategory,
                                  Phonon::MediaSource(audioFile->fileName()));

    qDebug()<<"done 3";
    connect(music, SIGNAL(finished()), this, SLOT(audioFinished()));



    reader->deleteLater();
}

void Audio::setAudio(QString filename)
{
    music = Phonon::createPlayer(Phonon::MusicCategory,
                                 Phonon::MediaSource(filename));


    connect(music, SIGNAL(finished()), this, SLOT(audioFinished()));
}

void Audio::audioFinished()
{
    this->finished();
}

void Audio::play()
{

    music->play();
}

void Audio::pause()
{
    music->pause();
}

